﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ATOUCHX;

namespace atouch_p15_en_02
{
    public partial class Form1 : Form
    {
        //Delegate declaration for communication between threads.
        private delegate void DelAlarm(int WID, int Param, object DATA);

        //Necessary objects and variables definition.
        AtouchApp App = new AtouchApp();
        int Err;

        public Form1()
        {
            //After-communication event handlers initialization. When App.xxx += is writed and then 
            //the Tab key is double pressed, the event code block is created automatically.
            App.DbAlarm += new _IAtouchAppEvents_DbAlarmEventHandler(App_DbAlarm);
            InitializeComponent();
        }

        void App_DbAlarm(int WID, int Param, object DATA)
        {
            if (this.InvokeRequired)
            {
                //The code is running in a different thread than in the UI thread. Therefore it is necessary
                //to use the Invoke method for thread-safe call on form controls.
                this.Invoke(new DelAlarm(App_DbAlarm), new Object[] { WID, Param, DATA });
                return;
            }
            //The code is running in the UI thread here and it is possible to call on form controls.
            In2Text.Text = DATA.ToString();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //Initialization method for DB-net network communication.
            Err = App.InitFromFile("hw.ini", "db.ini");
            App.VariantOnly = false;
            ErrText.Text = Err.ToString();
            //Turn on of alarm function for PC local variable with WID 31000.
            Err = App.DbSetAlarm(31000, 1);
            ErrText.Text = Err.ToString();
        }

        //DB-Net network communication termination.
        private void EndProg_Click(object sender, EventArgs e)
        {
            App.Done();
            this.Close();
        }

        //Periodic refreshing of the displayed local PC variable.
        private void timer1_Tick(object sender, EventArgs e)
        {
            //Control system sends the Int type of variable that is represented in C# type Int16.
            Object Data = Convert.ToInt16(0);
            Err = App.LocalGetData(31000, ref Data);
            ErrText.Text = Err.ToString();
            InText.Text = Data.ToString();
        }
    }
}
